# Compiler Error/Warning ADB0000

This message indicates that `adb` (Android Debug Bridge) reported an
unhandled/unexpected error or warning. `adb` is part of the Android
SDK and is used internally by Xamarin.Android to communicate with
Android emulators and devices. Learn more about `adb` from the
[Android documentation][adb].

Note that nothing in the open source `xamarin-android` repository
emits `ADB0000`, as features such as debugging and "fast deployment"
are implemented in the proprietary Xamarin.Android bits.

Errors reported by `adb` are very much outside of Xamarin.Android's
control, so a general error code of `ADB0000` is used for unexpected
errors reporting the exact message coming from `adb`.

An example message would be:
- `error ADB0000: error: no devices/emulators found`

[adb]: https://developer.android.com/studio/command-line/adb
