# Compiler Error/Warning ADB0010

This message indicates that `adb` (Android Debug Bridge) reported an
unhandled/unexpected error during APK installation. `adb` is part of
the Android SDK and is used internally by Xamarin.Android to
communicate with Android emulators and devices. Learn more about `adb`
from the [Android documentation][adb].

Note that nothing in the open source `xamarin-android` repository
emits `ADB0010`, as features such as debugging and "fast deployment"
are implemented in the proprietary Xamarin.Android bits.

Errors reported by `adb` are very much outside of Xamarin.Android's
control, so a general error code of `ADB0010` is used for unexpected
errors related to APK installation. An error message of the form
`[INSTALL_FAILED_*]` will emit this error code.

[adb]: https://developer.android.com/studio/command-line/adb
