# Compiler Error ADB0020

This message indicates that `adb` (Android Debug Bridge) reported an
error. `adb` is part of the Android SDK and is used internally by
Xamarin.Android to communicate with Android emulators and devices.
Learn more about `adb` from the [Android documentation][adb].

Note that nothing in the open source `xamarin-android` repository
emits `ADB0020`, as features such as debugging and "fast deployment"
are implemented in the proprietary Xamarin.Android bits.

`ADB0020` means that the built Android APK did not contain a matching
Android architecture for the emulator or device it was deployed to. A
solution is to add an additional architecture under the
`Supported architectures` in your project options.

You may also modify the MSBuild property, as in the following example
that includes all ABIs:

    <AndroidSupportedAbis>armeabi;armeabi-v7a;x86;x86_64;arm64-v8a</AndroidSupportedAbis>

An example message would be:
- `error ADB0020: Failure [INSTALL_FAILED_NO_MATCHING_ABIS]: Failed to extract native libraries`

[adb]: https://developer.android.com/studio/command-line/adb
