# Compiler Error ADB0040

This message indicates that `adb` (Android Debug Bridge) reported an
error. `adb` is part of the Android SDK and is used internally by
Xamarin.Android to communicate with Android emulators and devices.
Learn more about `adb` from the [Android documentation][adb].

Note that nothing in the open source `xamarin-android` repository
emits `ADB0040`, as features such as debugging and "fast deployment"
are implemented in the proprietary Xamarin.Android bits.

`ADB0040` means that you are trying to deploy to an emulator or device
that has an older Android version that what your Xamarin.Android
application supports.

Verify you are setting the appropriate values for `uses-sdk` in your
`AndroidManifest.xml`:

    <uses-sdk android:minSdkVersion="15" android:targetSdkVersion="27"/>

Your attached device must at least be able to support `minSdkVersion`.

An example message would be:
- `error ADB0040: Failure [INSTALL_FAILED_OLDER_SDK]`

[adb]: https://developer.android.com/studio/command-line/adb
