# Compiler Error XA4303

The `ResolveLibraryProjectImports` task encountered a failure
extracting `__AndroidLibraryProjects__.zip` from a referenced
assembly. This zip file contains any Android-related files embedded in
the assembly during the Xamarin.Android build process. This includes
`@(AndroidAsset)`, `@(AndroidResource)`, etc.

`XA4303` could be caused by any of the following:

  - A `PathTooLongException` occurred while extracting the zip file.
    Learn more about `MAX_PATH` on Windows [here][max_path].
  - An invalid path was encountered inside the zip file, such as `:` on
    Windows.

Consider submitting a [bug][bug] if you are getting this warning under
normal circumstances.

[max_path]: https://msdn.microsoft.com/en-us/library/windows/desktop/aa365247(v=vs.85).aspx#maxpath
[bug]: https://github.com/xamarin/xamarin-android/wiki/Submitting-Bugs,-Feature-Requests,-and-Pull-Requests
